%global momorel 2

%define python_sitelib %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")
%define python_sitearch %(python -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")
%define selinux_variants mls strict targeted
%define sca_version 0.4.5
%global sca_release 1
%global pyver 2.5
%global pythonver 2.5.1-11m

Summary: User space tools for 2.6 kernel auditing
Name: audit
Version: 1.7.4
Release: %{momorel}m%{?dist}
License: GPL
Group: System Environment/Daemons
URL: http://people.redhat.com/sgrubb/audit/
Source0: http://people.redhat.com/sgrubb/audit/%{name}-%{version}.tar.gz
NoSource: 0

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: libtool swig
BuildRequires: python-devel >= %{pythonver}
# BuildRequires: kernel-headers >= 2.6.18
BuildRequires: automake >= 1.9
BuildRequires: autoconf >= 2.59
BuildRequires: python-devel >= %{pythonver}
BuildRequires: gettext-devel intltool
BuildRequires: intltool >= 0.36.0
BuildRequires: perl-XML-Parser
BuildRequires: libprelude-devel >= 0.9.16
Requires: %{name}-libs = %{version}-%{release}
Requires: %{name}-libs-python = %{version}-%{release}
Requires: chkconfig
Prereq: coreutils
Obsoletes: audit-audispd-plugins

%description
The audit package contains the user space utilities for
storing and searching the audit records generate by
the audit subsystem in the Linux 2.6 kernel.

%package libs
Summary: Dynamic library for libaudit
License: LGPL
Group: Development/Libraries

%description libs
The audit-libs package contains the dynamic libraries needed for 
applications to use the audit framework.

%package libs-devel
Summary: Header files and static library for libaudit
License: LGPL
Group: Development/Libraries
Requires: %{name}-libs = %{version}-%{release}
# Requires: kernel-headers >= 2.6.18

%description libs-devel
The audit-libs-devel package contains the static libraries and header 
files needed for developing applications that need to use the audit 
framework libraries.

%package libs-python
Summary: Python bindings for libaudit
License: LGPL
Group: Development/Libraries
Requires: %{name}-libs = %{version}-%{release}
Requires: kernel-headers >= 2.6.17

%description libs-python
The audit-libs-python package contains the bindings so that libaudit
and libauparse can be used by python.

%package -n audispd-plugins
Summary: Plugins for the audit event dispatcher
License: GPLv2
Group: System Environment/Daemons
BuildRequires: openldap-devel
BuildRequires: checkpolicy selinux-policy-devel
Requires: %{name} = %{version}-%{release}
Requires: %{name}-libs = %{version}-%{release}
Requires: openldap
%if "%{selinux_policyver}" != ""
Requires: selinux-policy >= %{selinux_policyver}
%endif
Requires(post): policycoreutils
Requires(postun): policycoreutils

%description -n audispd-plugins
The audispd-plugins package provides plugins for the real-time
interface to the audit system, audispd. These plugins can do things
like relay events to remote machines or analyze events for suspicious
behavior.

%package -n system-config-audit
Summary: Utility for editing audit configuration
Version: %{sca_version}
Release: %{sca_release}m%{?dist}
License: GPL
Group: Applications/System
Requires: pygtk2-libglade usermode usermode-gtk

%description -n system-config-audit
An utility for editing audit configuration.

%prep
%setup -q

mkdir zos-remote-policy
cp -p audisp/plugins/zos-remote/policy/audispd-zos-remote.* zos-remote-policy

find . -type f | xargs perl -pi -e "s,rc.d/,,"

%build
(cd system-config-audit; ./autogen.sh)
autoreconf -if
export CFLAGS="$RPM_OPT_FLAGS"
%configure --sbindir=/sbin --libdir=/%{_lib} --with-prelude
%make
cd zos-remote-policy
for selinuxvariant in %{selinux_variants}
do
  if [ "${selinuxvariant}" = "mls" ]; then
    TYPE=mls-mls
  else
    TYPE=${selinuxvariant}-mcs
  fi
  make -f /usr/share/selinux/devel/Makefile
  mv audispd-zos-remote.pp audispd-zos-remote.pp.${selinuxvariant}
  make -f /usr/share/selinux/devel/Makefile clean
done
cd -

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}/{sbin,etc/{sysconfig,audispd/plugins.d,init.d}}
mkdir -p %{buildroot}/%{_mandir}/{man5,man8}
mkdir -p %{buildroot}/%{_lib}
mkdir -p %{buildroot}/usr/{lib,lib32}/audit
mkdir -p %{buildroot}/%{_var}/log/audit
make DESTDIR=%{buildroot} transform='s,x,x,' install
make -C system-config-audit DESTDIR=%{buildroot} install-fedora
for selinuxvariant in %{selinux_variants}
do
  install -d %{buildroot}/%{_datadir}/selinux/${selinuxvariant}
  install -p -m 644 zos-remote-policy/audispd-zos-remote.pp.${selinuxvariant} \
    %{buildroot}/%{_datadir}/selinux/${selinuxvariant}/audispd-zos-remote.pp
done

mkdir -p %{buildroot}/%{_libdir}
# This winds up in the wrong place when libtool is involved
mv %{buildroot}/%{_lib}/libaudit.a %{buildroot}%{_libdir}
mv %{buildroot}/%{_lib}/libauparse.a %{buildroot}%{_libdir}
curdir=`pwd`
cd %{buildroot}/%{_libdir}
LIBNAME=`basename \`ls %{buildroot}/%{_lib}/libaudit.so.*.*.*\``
ln -s ../../%{_lib}/$LIBNAME libaudit.so
LIBNAME=`basename \`ls %{buildroot}/%{_lib}/libauparse.so.*.*.*\``
ln -s ../../%{_lib}/$LIBNAME libauparse.so
cd $curdir
# Remove these items so they don't get picked up.
rm -f %{buildroot}/%{_lib}/libaudit.so
rm -f %{buildroot}/%{_lib}/libauparse.so
rm -f %{buildroot}/%{_lib}/libaudit.la
rm -f %{buildroot}/%{_lib}/libauparse.la
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_audit.a
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_audit.la
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_auparse.a
rm -f %{buildroot}/%{_libdir}/python*/site-packages/_auparse.la

# On platforms with 32 & 64 bit libs, we need to coordinate the timestamp
touch -r ./audit.spec %{buildroot}%{_sysconfdir}/libaudit.conf

%find_lang system-config-audit

desktop-file-install                                   \
       --dir %{buildroot}/%{_datadir}/applications  \
       --vendor ""   \
       --delete-original                               \
       system-config-audit/system-config-audit.desktop

# This is a reminder to enable it when tests
# aren't based on postfix uids
#% check
#make check

%clean
rm -rf %{buildroot}
rm -rf zos-remote-policy

%post libs -p /sbin/ldconfig

%post -n audispd-plugins
for selinuxvariant in %{selinux_variants}
do
  /usr/sbin/semodule -s $selinuxvariant \
    -i %{_datadir}/selinux/$selinuxvariant/audispd-zos-remote.pp \
    &> /dev/null || :
done
/sbin/restorecon -F /sbin/audispd-zos-remote /etc/audisp/zos-remote.conf

%post
/sbin/chkconfig --add auditd
if [ -f /etc/auditd.conf ]; then
   mv /etc/auditd.conf /etc/audit/auditd.conf
fi
if [ -f /etc/audit.rules ]; then
   mv /etc/audit.rules /etc/audit/audit.rules
fi
if [ -f /etc/audit/auditd.conf ]; then
   grep '^dispatcher' /etc/audit/auditd.conf >/dev/null
   if [ $? -eq 1 ] ; then
      tmp=`mktemp /etc/audit/auditd-post.XXXXXX`
      if [ -n $tmp ]; then
         sed 's|^#dispatcher|dispatcher|g' /etc/audit/auditd.conf > $tmp && \
         cat $tmp > /etc/audit/auditd.conf
         rm -f $tmp
      fi
   fi
fi

%preun
if [ $1 -eq 0 ]; then
   /sbin/service auditd stop > /dev/null 2>&1
   /sbin/chkconfig --del auditd
fi

%postun libs -p /sbin/ldconfig

%postun -n audispd-plugins
if [ $1 -eq 0 ]; then
 for selinuxvariant in %{selinux_variants}
 do
   /usr/sbin/semodule -s $selinuxvariant -r audispd-zos-remote &>/dev/null || :
 done
fi

%postun
if [ $1 -ge 1 ]; then
   /sbin/service auditd condrestart > /dev/null 2>&1 || :
fi

%files libs
%defattr(-,root,root)
%attr(755,root,root) /%{_lib}/libaudit.*
%attr(755,root,root) /%{_lib}/libauparse.*
%config(noreplace) %attr(640,root,root) /etc/libaudit.conf

%files libs-devel
%defattr(-,root,root)
%doc contrib/skeleton.c contrib/plugin
%{_libdir}/libaudit.a
%{_libdir}/libauparse.a
%{_libdir}/libaudit.so
%{_libdir}/libauparse.so
%{_includedir}/libaudit.h
%{_includedir}/auparse.h
%{_includedir}/auparse-defs.h
%{_mandir}/man3/*

%files libs-python
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/python?.?/site-packages/_audit.so
%attr(755,root,root) %{_libdir}/python?.?/site-packages/auparse.so
%{_libdir}/python?.?/site-packages/auparse-*.egg-info
%{python_sitelib}/audit.py*

%files
%defattr(-,root,root,-)
%doc  README COPYING ChangeLog contrib/capp.rules contrib/nispom.rules contrib/lspp.rules init.d/auditd.cron
%doc  README COPYING ChangeLog contrib/capp.rules contrib/nispom.rules contrib/lspp.rules contrib/stig.rules init.d/auditd.cron
%attr(644,root,root) %{_mandir}/man8/audispd.8.*
%attr(644,root,root) %{_mandir}/man8/auditctl.8.*
%attr(644,root,root) %{_mandir}/man8/auditd.8.*
%attr(644,root,root) %{_mandir}/man8/aureport.8.*
%attr(644,root,root) %{_mandir}/man8/ausearch.8.*
%attr(644,root,root) %{_mandir}/man8/autrace.8.*
%attr(644,root,root) %{_mandir}/man8/aulastlog.8.*
%attr(644,root,root) %{_mandir}/man8/ausyscall.8.*
%attr(644,root,root) %{_mandir}/man5/auditd.conf.5.*
%attr(644,root,root) %{_mandir}/man5/audispd.conf.5.*
%attr(644,root,root) %{_mandir}/man5/ausearch-expression.5.*
%attr(750,root,root) /sbin/auditctl
%attr(750,root,root) /sbin/auditd
%attr(755,root,root) /sbin/ausearch
%attr(755,root,root) /sbin/aureport
%attr(750,root,root) /sbin/autrace
%attr(750,root,root) /sbin/audispd
%attr(750,root,root) %{_bindir}/aulastlog
%attr(755,root,root) %{_bindir}/ausyscall
%attr(755,root,root) %{_initscriptdir}/auditd
%attr(750,root,root) %{_var}/log/audit
%attr(750,root,root) %dir /etc/audit
%attr(750,root,root) %dir /etc/audisp
%attr(750,root,root) %dir /etc/audisp/plugins.d
%attr(750,root,root) %dir %{_prefix}/lib/audit
%config(noreplace) %attr(640,root,root) /etc/audit/auditd.conf
%config(noreplace) %attr(640,root,root) /etc/audit/audit.rules
%config(noreplace) %attr(640,root,root) /etc/sysconfig/auditd
%config(noreplace) %attr(640,root,root) /etc/audisp/audispd.conf
%config(noreplace) %attr(640,root,root) /etc/audisp/plugins.d/af_unix.conf

%files -n audispd-plugins
%defattr(-,root,root,-)
%attr(640,root,root) /etc/audisp/plugins.d/syslog.conf
%attr(644,root,root) %{_mandir}/man8/audispd-zos-remote.8.*
%attr(644,root,root) %{_mandir}/man5/zos-remote.conf.5.*
%config(noreplace) %attr(640,root,root) /etc/audisp/plugins.d/audispd-zos-remote.conf
%config(noreplace) %attr(640,root,root) /etc/audisp/zos-remote.conf
%attr(750,root,root) /sbin/audispd-zos-remote
%attr(644,root,root) %{_datadir}/selinux/*/audispd-zos-remote.pp
%config(noreplace) %attr(640,root,root) /etc/audisp/plugins.d/au-prelude.conf
%config(noreplace) %attr(640,root,root) /etc/audisp/audisp-prelude.conf
%attr(750,root,root) /sbin/audisp-prelude
%attr(644,root,root) %{_mandir}/man5/audisp-prelude.conf.5.*
%attr(644,root,root) %{_mandir}/man8/audisp-prelude.8.*
%config(noreplace) %attr(640,root,root) /etc/audisp/audisp-remote.conf
%config(noreplace) %attr(640,root,root) /etc/audisp/plugins.d/au-remote.conf
%attr(750,root,root) /sbin/audisp-remote
%attr(644,root,root) %{_mandir}/man5/audisp-remote.conf.5.*
%attr(644,root,root) %{_mandir}/man8/audisp-remote.8.*

%files -n system-config-audit -f system-config-audit.lang
%defattr(-,root,root,-)
%doc system-config-audit/AUTHORS
%doc system-config-audit/COPYING
%doc system-config-audit/ChangeLog
%doc system-config-audit/NEWS
%doc system-config-audit/README
%{_bindir}/system-config-audit
%{_datadir}/applications/system-config-audit.desktop
%{_datadir}/system-config-audit
%{_libexecdir}/system-config-audit-server-real
%{_libexecdir}/system-config-audit-server
%config(noreplace) %{_sysconfdir}/pam.d/system-config-audit-server
%config(noreplace) %{_sysconfdir}/security/console.apps/system-config-audit-server

%changelog
* Fri May 23 2008 Masanobu Sato <satoshiga@momonga-linux.org>
- (1.7.4-2m)
- revised %%files section for x86_64

* Wed May 21 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.7.4-1m)
- update 1.7.4

* Wed Apr 30 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.6.3-7m)
- restrict python ver-rel for egginfo

* Sat Apr 26 2008 Masahiro Takahata <takahata@momonga-linux.org>
- (1.6.3-6m)
- enable egg-info

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.6.3-5m)
- rebuild against gcc43

* Wed Feb 27 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.6.3-4m)
- rebuild against openldap-2.4.8

* Wed Jan  2 2008 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.6.3-3m)
- modify Requires of audispd-plugins

* Sun Dec 30 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.6.3-2m)
- adjust duplicate files

* Sat Dec 29 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.6.3-1m)
- update to 1.6.3
- update system-config-audit to 0.4.5-1m
- add audispd-plugins package
- sync with Fedora devel

* Sat Aug 18 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.5.5-3m)
- modify %%files section
-- use %%{_sysconfdir}, %%{_initscriptdir} and so on

* Wed Aug 15 2007 Nishio Futoshi <futoshi@momonga-linux>
- (1.5.5-2m)
- add patch2 for new intltool

* Sun Aug 12 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.5.5-1m)
- update to 1.5.5
- sync with FC-devel
- add sub package system-config-audit
- import two patches from FC

* Thu Jul  5 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.5.4-1m)
- update to 1.5.4

* Sun Jun  3 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.5.3-1m)
- update to 1.5.3
- NoSource and adjust %%files section

* Mon May  7 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.5.2-2m)
- add Obsoletes: audit-audispd-plugins, it has no %%files

* Wed May  2 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.5.2-1m)
- update 1.5.2

* Sun Mar 11 2007 Masanobu Sato <satoshiga@momonga-linux.org>
- (1.5-3m)
- add python libdir macro and modify python libdir

* Sat Mar 10 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (1.5-2m)
- modify libdir

* Thu Mar  8 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.5-1m)
- update 1.5
- create audit-audispd-plugins package

* Mon Feb 26 2007 Masahiro Takahata <takahata@momonga-linux.org>
- (1.4.1-2m)
- modify pydir

* Tue Feb 20 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.4.1-1m)
- update 1.4.1 

* Thu Feb 15 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.4-2m)
- remove Requires: kernel-headers for the moment

* Thu Feb 15 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.4-1m)
- update 1.4 

* Tue Feb  6 2007 Nishio Futoshi <futoshi@momonga-linux.org>
- (1.2.5-4m)
- delete pyc pyo

* Sun Dec 24 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.2.5-3m)
- fix python modue install path

* Sat Dec 23 2006 Yohsuke Ooi <meke@momonga-linux.org>
- (1.2.5-2m)
- rebuild against python-2.5

* Sat Jul 29 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.2.5-1m)
- version up

* Fri May 12 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.5-1m)
- version up

* Wed May 10 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.3-2m)
- rebuild against swig

* Sun Feb 12 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.1.3-1m)
- import from fc-devel

* Thu Jan 5 2006 Steve Grubb <sgrubb@redhat.com> 1.1.3-1
- Add timestamp to daemon_config messages (#174865)
- Add error checking of year for aureport & ausearh
- Treat af_unix sockets as files for searching and reporting
- Update capp & lspp rules to combine syscalls for higher performance
- Adjusted the chkconfig line for auditd to start a little earlier
- Added skeleton program to docs for people to write their own dispatcher with
- Apply patch from Ulrich Drepper that optimizes resource utilization
- Change ausearch and aureport to unlocked IO

* Thu Dec 5 2005 Steve Grubb <sgrubb@redhat.com> 1.1.2-1
- Add more message types

* Wed Nov 30 2005 Steve Grubb <sgrubb@redhat.com> 1.1.1-1
- Add support for alpha processors
- Update the audisp code
- Add locale code in ausearch and aureport
- Add new rule operator patch
- Add exclude filter patch
- Cleanup make files
- Add python bindings

* Wed Nov 9 2005 Steve Grubb <sgrubb@redhat.com> 1.1-1
- Add initial version of audisp. Just a placeholder at this point
- Remove -t from auditctl

* Mon Nov 7 2005 Steve Grubb <sgrubb@redhat.com> 1.0.12-1
- Add 2 more summary reports
- Add 2 more message types

